/*
Connor Dial
CSCI 4270
Assignment 4
March 18th, 2024
This is the "MergeSortImplementation" java class that will handle the implementation of MergeSort so that it can be
used in the main java class.
 */


import java.util.Arrays;
public class MergeSortImplementation {

    public static long number_of_steps;

    public static void mergeSort(int[] array) {
        mergeSortHelper(array, 0, array.length - 1);

    }

    public static void mergeSort(int[] array, long nos_runtime_steps_start) {
        number_of_steps = nos_runtime_steps_start;
        mergeSortHelper(array, 0, array.length - 1);
    }

    public static void mergeSortHelper(int[] array, int low, int high) {

        number_of_steps++;
        if (low < high) {
            int mid = low + (high - low) / 2;
            mergeSortHelper(array, low, mid);
            mergeSortHelper(array, mid + 1, high);
            merge(array, low, mid, high);
        }
    }
    public static void merge(int[] array, int low, int mid, int high) {

        int[] left = Arrays.copyOfRange(array, low, mid + 1);
        int[] right = Arrays.copyOfRange(array, mid + 1, high + 1);
        int i = 0, j = 0;

        while (i < left.length && j < right.length) {
            if (left[i] <= right[j]) {
                array[low++] = left[i++];
            } else {
                array[low++] = right[j++];
            }
        }
        while (i < left.length) {
            array[low++] = left[i++];
        }
        while (j < right.length) {
            array[low++] = right[j++];
        }
    }


}
