/*
Connor Dial
CSCI 4270
Assignment 4
March 18th, 2024
This is the "QuickSortImplementation" java class that will handle the implementation of QuickSort so that it can be
used in the main java class.
 */

public class QuickSortImplementation {

    public static long number_of_steps = 0;
    public static void quickSort(int[] array, int low, int high) {

        if (low < high) {
            int pivotIndex = partition(array, low, high);
            quickSort(array, low, pivotIndex - 1);
            quickSort(array, pivotIndex + 1, high);
        }
    }

    public static void quickSort(int[] array, int low, int high, long number_of_steps_start) {

        number_of_steps++;
        if (low < high) {
            int pivotIndex = partition(array, low, high);
            quickSort(array, low, pivotIndex - 1);
            quickSort(array, pivotIndex + 1, high);
        }
    }


    public static int partition(int[] array, int low, int high) {

        int pivot = array[high];
        int i = low - 1;
        for (int j = low; j < high; j++) {
            if (array[j] <= pivot) {
                i++;
                swap(array, i, j);
            }
        }
        swap(array, i + 1, high);
        return i + 1;
    }

    private static void swap(int[] array, int i, int j) {

        int temp = array[i];
        array[i] = array[j];
        array[j] = temp;
    }

}
