/*
Connor Dial
CSCI 4270
Assignment 4
March 18th, 2024
This is the main java class for this assignment. It uses the QuickSortImplementation class and the MergeSortImplementation
class to sort 10,000 arrays of size 1000. It also uses another class called "standardDeviationCalculator" as well as a
randomArrayGenerator to both generate arrays and to print a report of these arrays.
 */

import java.io.IOException;
import java.util.Arrays;

public class SortingAlgorithms {

    public static void main(String[] args) throws IOException {

        int numberOfArrays = 10000;
        int arraySize = 1000;
        long[] ms_rts = new long[numberOfArrays];
        long[] qs_rts = new long[numberOfArrays];

        MergeSortImplementation msi = new MergeSortImplementation();
        QuickSortImplementation qsi = new QuickSortImplementation();
        randomArrayGenerator rag = new randomArrayGenerator();
        standardDeviationCalculator std = new standardDeviationCalculator();


        for (int i = 0; i < numberOfArrays; i++) {
            int[] array = rag.generateArray(arraySize);

            long nos_runtime_steps_merge_start = 0;
            msi.mergeSort(array.clone(), nos_runtime_steps_merge_start);
            long ms_rt = MergeSortImplementation.number_of_steps;
            ms_rts[i] = ms_rt;

            long nos_runtime_steps_quick_start = 0;
            qsi.quickSort(array.clone(), 0, arraySize - 1, nos_runtime_steps_quick_start);
            long qs_rt = QuickSortImplementation.number_of_steps;
            qs_rts[i] = qs_rt;

        }

        Arrays.sort(ms_rts);
        Arrays.sort(qs_rts);

        long mergeSortMin = ms_rts[0];
        long mergeSortMax = ms_rts[numberOfArrays - 1];
        long mergeSortSum = Arrays.stream(ms_rts).sum();
        long mergeSortAverage = (long) (mergeSortSum / (double) numberOfArrays);
        long mergeSortStandardDeviation = std.calculate(ms_rts, mergeSortAverage);

        long quickSortMin = qs_rts[0];
        long quickSortMax = qs_rts[numberOfArrays - 1];
        long quickSortSum = Arrays.stream(qs_rts).sum();
        long quickSortAverage = (long) (quickSortSum / (double) numberOfArrays);
        long quickSortStandardDeviation = std.calculate(qs_rts, quickSortAverage);

        // The commands below print all the run-time calculations for the two sorting methods. (QuickSort & MergeSort).

        System.out.println("Merge Sort Calculations:");
        System.out.println("Minimum Runtime: " + mergeSortMin);
        System.out.println("Maximum Runtime: " + mergeSortMax);
        System.out.println("Average Runtime: " + mergeSortAverage);
        System.out.println("Standard Deviation: " + mergeSortStandardDeviation);

        System.out.println("\nQuick Sort Calculations:");
        System.out.println("Minimum Runtime: " + quickSortMin);
        System.out.println("Maximum Runtime: " + quickSortMax);
        System.out.println("Average Runtime: " + quickSortAverage);
        System.out.println("Standard Deviation: " + quickSortStandardDeviation + "\n");

        rag.ArrayReportCreator(); // This creates a report.
    }

}

